#!/usr/bin/python
# ======================================================================
# train.py - USBtiny/ir-switch programmer
#
# Copyright 2010 Matthias Hopf
# ======================================================================

import sys, os.path
sys.path[0] = os.path.join(sys.path[0], '../util')
import usbtiny

vendor  = 0x03eb
product = 0x0002

IGORPLUG_CLEAR	= 1	# clear IR data
SWITCH_PROG	= 30	# program switch EEPROM data

dev = usbtiny.USBtiny(vendor, product)
dev.control_in(IGORPLUG_CLEAR, 0, 0, 0)

if len(sys.argv) <= 1:
	print >> sys.stderr, "Usage:", sys.argv[0], "<hex0> <hex1> <hex2> ..."
else:
	i = 0
	for x in sys.argv[1:]:
		data = ''.join([ chr(i), chr(int(x,16)) ])
		dev.control_out(SWITCH_PROG, 0, 0, data)
		i+=1
	print "Programmed %d values" % (len(sys.argv)-1)
	dev.control_in(IGORPLUG_CLEAR, 0, 0, 0)

