#!/usr/bin/python
# ======================================================================
# train.py - USBtiny/ir-switch trainer
#
# Copyright 2010 Matthias Hopf
# ======================================================================

import sys, os.path
sys.path[0] = os.path.join(sys.path[0], '../util')
import usbtiny

vendor  = 0x03eb
product = 0x0002

IGORPLUG_CLEAR	= 1	# clear IR data
IGORPLUG_READ	= 2	# read IR data (wValue: offset)
LCD_INSTR	= 20	# write instructions to LCD (via OUT)
LCD_DATA	= 21	# write data to LCD (via OUT)

dev = usbtiny.USBtiny(vendor, product)
dev.control_in(IGORPLUG_CLEAR, 0, 0, 0)
have = 0
needed = 30

last = -1
cont = 1
avg = []
while cont > 0:
	data = dev.control_in(IGORPLUG_READ, 0, 0, 3 + 36)
	if len(data) >= 3 and data[1] == last:
		dev.control_in(IGORPLUG_CLEAR, 0, 0, 0)
	if len(data) >= 3 and data[1] != last:
		last = data[1]
		if len(data) != ord(data[0])+3:
			print >> sys.stderr, "bad packet"
			cont = -1
		if have == 0:
			avg  = [ord(data[i+3]) for i in range(len(data)-3)]
			dmin = avg[:]
			dmax = avg[:]
			have+=1
		elif len(data)-3 == len(avg):
#			print "%03d %03d:" % (have, ord(data[1])) ,
#			for i in range(3,len(data)):
#				print "%02x" % ord(data[i]),
#			print
			for i in range(0,len(avg)):
				avg[i] += ord(data[i+3])
				dmin[i] = min(dmin[i],ord(data[i+3]))
				dmax[i] = max(dmax[i],ord(data[i+3]))
				if dmax[i]-dmin[i] > 3:
					print >> sys.stderr, "threshold exceeded"
					cont=-1
					break
			if cont > 0:
				print >> sys.stderr, ".",
				have+=1
				if have >= needed:
					cont = 0
		else:
			print >> sys.stderr, "short/long packet"
			cont = -1
		print "  " ,
maxdiff = 0
print
if len(avg) > 0:
	for i in range(len(avg)):
		print "%d-%d" % (dmin[i],dmax[i]),
		maxdiff = max(maxdiff,dmax[i]-dmin[i])
print
print "Maximum difference: %d" % maxdiff
if cont == 0:
	print "Success."
else:
	print "Nice try."
